
/******************************************************************************
*	FpsTimer Class Source
******************************************************************************/

#include "stdafx.h"
#include "FpsTimer.h"
#ifdef SLIB_USE_FPSTIMER


LONGLONG	CFpsTimer::m_llTicksPerSecond = 0;
BOOL		CFpsTimer::m_bHighAccurate = 0;
TIMECAPS	CFpsTimer::m_tc = {0};
UINT		CFpsTimer::m_timer_res = 0;
DWORD		CFpsTimer::m_dwReference = 0;


/*----------------------------------------------------------------------------*
|	RXgN^
|
|	DWORD dwFPS=TIMER_NOWAIT cFPSlݒ
|	BOOL bHighTimer cx^C}gp邩
*----------------------------------------------------------------------------*/
CFpsTimer::CFpsTimer( DWORD dwFPS, BOOL bHighTimer )
{

	m_dwReference++;

	if( m_timer_res == 0 )
	{
		// ^C}x̌
		if (::timeGetDevCaps(&m_tc, sizeof(TIMECAPS)) == TIMERR_NOERROR)
		{
			// T|[gĂŏ^C}xo
			m_timer_res = min(max(m_tc.wPeriodMin, 1 ), m_tc.wPeriodMax);

			// ŏ^C}xݒ
			::timeBeginPeriod(m_timer_res);

		}
	}

	// x^C}g擾ڂ̗L
	m_bHighAccurate = ::QueryPerformanceFrequency( ( LARGE_INTEGER* )&m_llTicksPerSecond );

	// FPSݒ
	m_dwFPS = dwFPS;

	// x^C}gp̗L
	UsePerformanceCounter( bHighTimer );

}


/*----------------------------------------------------------------------------*
|	RXgN^
*----------------------------------------------------------------------------*/
CFpsTimer::~CFpsTimer()
{

	if( --m_dwReference == 0 )
	{
		if( m_timer_res > 0 )
		{

			// 蓖Ă^C}\[X
			::timeEndPeriod(m_timer_res);
			m_timer_res = 0;
		}		
	}
}


/*----------------------------------------------------------------------------*
|	ҋ@t[
*----------------------------------------------------------------------------*/
void CFpsTimer::WaitFrame( void )
{


	if( m_bHighTimer && m_bHighAccurate )
	{
		// ݂̎Ԃ擾
		LONGLONG llNowTime = GetPerformanceCounter();


		{
			// m[EFCg̎
			if( m_dwFPS == FPSTIMER_NOWAIT )	goto NEXT1;
			

			// ݂̌oߎ
			LONGLONG llElpaseTime = llNowTime - m_llLastTime;

			// ݂̌oߎԂҋ@鎞Ԃ葽Ƃ(܂菈Ăꍇ)
			if( llElpaseTime >= m_llWaitTime )	goto NEXT1;
		
		
			// ҋ@̎
			LONGLONG llNextTime = llNowTime+(m_llWaitTime-llElpaseTime);

			// ]ԃ[v
			while(llNextTime > (llNowTime=GetPerformanceCounter())) ;
		}

NEXT1:

		// 1t[̌oߎԂ~bŏo
		m_fTimeElapsed = (llNowTime-m_llLastTime) * m_fTimeScale;


		// ݂̎ԂL^
		m_llLastTime = llNowTime;


		// ݂̎Ԃۑ
		m_llFrameTime[ m_dwFrameTimeCount & 63 ] = llNowTime;
		if( ++m_dwFrameTimeCount == 128 ) m_dwFrameTimeCount = 64;


		// 1bXVpt[JE^[
		m_dwFrameCount++;

		// 1bXVpFPSJEg
		if( m_llFpsNextTime <= llNowTime )
		{
			m_fFps = (float)(m_llTicksPerSecond*m_dwFrameCount)/(llNowTime-m_llFpsLastTime);	// ^FPSl
			m_dwFps = m_dwFrameCount;						// ^FPSl
			m_dwFrameCount = 0;								// t[JE^[
			m_llFpsLastTime = llNowTime;					// FPSXV̎ԂL^
			m_llFpsNextTime = llNowTime+m_llTicksPerSecond;	// FPSXV
		}

	}else
	{
		// ݂̎Ԃ擾
		DWORD dwNowTime = ::timeGetTime();
		
		DWORD dwNowWait;
		
		{

			// m[EFCg̎
			if( m_dwFPS == FPSTIMER_NOWAIT ) goto NEXT2;


			// ɂĂ1t[̑ҋ@(ms)Z
			m_dwNowWaitTime = (m_dwNowWaitTime & 0xFFFF) + m_dwWaitTime;
 
			// ҋ@鎞(ms)
			dwNowWait = m_dwNowWaitTime >> 16;

			// ݂̌oߎ(ms)
			DWORD dwElpaseTime = dwNowTime - m_dwLastTime;

			// ݂̌oߎ(ms)ҋ@鎞(ms)葽Ƃ(܂菈Ăꍇ)
			if( dwElpaseTime >= dwNowWait )	goto NEXT2;

			// ]Ԃ̓X[v
			::Sleep( dwNowWait - dwElpaseTime );

			// ݂̎(ҋ@Ԃo߂̂ƌȂ)
			dwNowTime = m_dwLastTime + dwNowWait;

		}
NEXT2:

		// 1t[̌oߎԂ~bŏo
		m_fTimeElapsed = (dwNowTime-m_dwLastTime) * m_fTimeScale;

		// ݂̎ԂL^
		m_dwLastTime = dwNowTime;
		
		// ݂̎Ԃۑ
		m_dwFrameTime[ m_dwFrameTimeCount & 63 ] = dwNowTime;
		if( ++m_dwFrameTimeCount == 128 ) m_dwFrameTimeCount = 64;

		
		// 1bXVpt[JE^[
		m_dwFrameCount++;

		// 1bXVpFPSJEg
		if( m_dwFpsNextTime <= dwNowTime )
		{
			m_fFps = (float)(1000*m_dwFrameCount)/(dwNowTime-m_dwFpsLastTime);	// ^FPSl
			m_dwFps = m_dwFrameCount;						// ^FPSl
			m_dwFrameCount = 0;								// t[JE^[
			m_dwFpsLastTime = dwNowTime;					// FPSXV̎ԂL^
			m_dwFpsNextTime = dwNowTime+1000;				// FPSXV
		}

	}
}


/*----------------------------------------------------------------------------*
|	FPSl̎擾 ( ľܓ )
|
|	DWORD type cFPS̎擾^Cv(֐̃I[o[[h)
|	bool real c펞FPSl擾邩ǂ
*----------------------------------------------------------------------------*/
DWORD CFpsTimer::GetFPS( DWORD type, bool real )
{

	if( !real ) return m_dwFps;

	if( m_bHighTimer && m_bHighAccurate )
	{
		if (m_dwFrameTimeCount < 32) return 0;

		// 31JEgȏ64JEg
		if (m_dwFrameTimeCount < 64)
		{
			LONGLONG t = m_llFrameTime[ m_dwFrameTimeCount-1 ]- m_llFrameTime[ m_dwFrameTimeCount-32 ];
			
			if ( t == 0 ) return 0;

			return (DWORD)((m_llTicksPerSecond*31+(t>>1))/t);
		}
		
		// 63JEgȏ128JEg(C)
		LONGLONG t = m_llFrameTime[ (m_dwFrameTimeCount-1) & 63 ] // ̎
			- m_llFrameTime[ (m_dwFrameTimeCount) & 63 ]; // 63O̎
		
		if ( t == 0 ) return 0;

		// fps = 1bԂ̎ԁ1t[̎
		// fps = t[~1bԂ̎ԁt[̎
		// fps(ľܓ) = (t[~1bԂ̎+t[̔)t[̎
		return (DWORD)((m_llTicksPerSecond*63+(t>>1))/t);

	}else
	{
		if (m_dwFrameTimeCount < 32) return 0;

		if (m_dwFrameTimeCount < 64)
		{
			DWORD t = m_dwFrameTime[ m_dwFrameTimeCount-1 ] - m_dwFrameTime[ m_dwFrameTimeCount-32 ];
			
			if ( t == 0 ) return 0;

			return (1000*31+(t>>1))/t;
		}
		
		DWORD t = m_dwFrameTime[ (m_dwFrameTimeCount-1) & 63 ] - m_dwFrameTime[ (m_dwFrameTimeCount) & 63 ];

		if ( t == 0 ) return 0;

		return (1000*63+(t>>1))/t;
	}
}


/*----------------------------------------------------------------------------*
|	FPSl̎擾 ()
|
|	DWORD type cFPS̎擾^Cv(֐̃I[o[[h)
|	bool real c펞FPSl擾邩ǂ
*----------------------------------------------------------------------------*/
float CFpsTimer::GetFPS( float type, bool real )
{

	if( !real ) return m_fFps;

	if( m_bHighTimer && m_bHighAccurate )
	{
		if (m_dwFrameTimeCount < 32) return 0;

		if (m_dwFrameTimeCount < 64)
		{
			LONGLONG t = m_llFrameTime[ m_dwFrameTimeCount-1 ] - m_llFrameTime[ m_dwFrameTimeCount-32 ];
			
			if ( t == 0 ) return 0;

			return (float)(m_llTicksPerSecond*31)/t;
		}
		
		LONGLONG t = m_llFrameTime[ (m_dwFrameTimeCount-1) & 63 ] - m_llFrameTime[ (m_dwFrameTimeCount) & 63 ];
		
		if ( t == 0 ) return 0;

		return (float)(m_llTicksPerSecond*63)/t;

	}else
	{
		if (m_dwFrameTimeCount < 32) return 0;

		if (m_dwFrameTimeCount < 64)
		{
			DWORD t = m_dwFrameTime[ m_dwFrameTimeCount-1 ] - m_dwFrameTime[ m_dwFrameTimeCount-32 ];
			
			if ( t == 0 ) return 0;

			return (float)(1000*31)/t;
		}
		
		DWORD t = m_dwFrameTime[ (m_dwFrameTimeCount-1) & 63 ] - m_dwFrameTime[ (m_dwFrameTimeCount) & 63 ];
		
		if ( t == 0 ) return 0;

		return (float)(1000*63)/t;
	}
}


/*----------------------------------------------------------------------------*
|	FPS̐ݒ
|
|	DWORD dwFPS=TIMER_NOWAIT cFPSlݒ
*----------------------------------------------------------------------------*/
void CFpsTimer::SetFPSValue( DWORD dwFPS )
{

	m_dwFPS = dwFPS;

	if( m_bHighAccurate )
	{
		// ݂̎Ԃ擾
		m_llLastTime = GetPerformanceCounter();
		m_llFpsLastTime = m_llLastTime;
		m_llFpsNextTime = m_llLastTime+m_llTicksPerSecond;
		::ZeroMemory( m_llFrameTime, sizeof(LONGLONG)*64);
	}

	// ݂̎Ԃ擾
	m_dwLastTime = ::timeGetTime();
	m_dwFpsLastTime = m_dwLastTime;
	m_dwFpsNextTime = m_dwLastTime+1000;
	::ZeroMemory( m_dwFrameTime, sizeof(DWORD)*64);

	
	// JE^[
	m_dwFrameTimeCount = 0;
	m_dwFrameCount = 0;
	m_dwFps = 0;
	m_fFps = 0;
	m_fTimeElapsed = 0;

	// FPSlm[EFCgȂ߂
	if( m_dwFPS == FPSTIMER_NOWAIT ) return;

	m_llWaitTime = m_llTicksPerSecond / m_dwFPS;

	// 1t[ő҂^CŒ菭ɂ(1000/60=16.6666...)
	m_dwWaitTime = (1000 << 16) / m_dwFPS;

	m_dwNowWaitTime = 0;

}


#endif /* SLIB_USE_FPSTIMER */