// UniversalTransition.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

#include "SDIB32GL.H"
#include "fpstimer.h"
#include "util.h"

/*** C^[tFCX̏ ***/
LPSDIB32GLFACTORY	lpSDFactory = NULL;
LPSDIB32GL			lpBack		= NULL;
LPSDIB32GL			lpTransBg	= NULL;
LPSDIB32GL			lpBg		= NULL;
LPSDIB32GL			lpRule		= NULL;


const BSTR lpwszBgName[] = { 
	MEDIAPATH(OLESTR("OEh.jpg")), 
	MEDIAPATH(OLESTR("ejXR[g.jpg")),
	MEDIAPATH(OLESTR("t@~X.jpg")),
	MEDIAPATH(OLESTR("t@~XX.jpg")),
	MEDIAPATH(OLESTR(".jpg")),
	MEDIAPATH(OLESTR("wH.jpg")),
	MEDIAPATH(OLESTR(".jpg")),
	MEDIAPATH(OLESTR("̓.jpg")),
	MEDIAPATH(OLESTR("~.jpg")),
	MEDIAPATH(OLESTR("EnL.jpg")),
	MEDIAPATH(OLESTR("p.jpg")),
	MEDIAPATH(OLESTR("{.jpg")),
};

#define TRANSLIBPATH( name )	"../../../TransLib/"##name
#define TRANSFILE	"trans.txt"

struct {
	DWORD	dwBgID;
	DWORD	dwTransBgID;
	DWORD	dwFilePos;
	char	szRuleName[256];
	BYTE	Vague;				// l
	DWORD	dwPhase;			// tFCY
	bool	bTransition;
}trans = { 0, 0, 0, "", 0, 0, false };

extern CFpsTimer FpsTimer;
void LoadRuleImage( void );
void SwapBG( void );


/*----------------------------------------------------------------------------*
|	App
*----------------------------------------------------------------------------*/
BOOL AppInitialize( void )
{
	HRESULT hr;

	try
	{
		// t@NgC^[tFCX擾
		hr = SDIB32GLFactoryCreate( 
			SDIB32GLCREATE_AUTO, (void**)&lpSDFactory, IID_ISDib32GLFactory );

		if( FAILED( hr ) )
		{
			throw exception("t@NgC^[tFCXs");
		}

		// NCAg̈TCỸobNobt@쐬
		hr = lpSDFactory->CreateBuffer(
			CLIENT_WIDTH, CLIENT_HEIGHT, 0, NULL, &lpBack );

		if( FAILED( hr ) )
		{
			throw exception("obNobt@̍쐬Ɏs");
		}
		
		// gWVobt@̍쐬
		hr = lpSDFactory->DuplicateBuffer( lpBack, &lpTransBg );

		if( FAILED( hr ) )
		{
			throw exception("gWVobt@̍쐬Ɏs");
		}

		RANDOMIZE;
		
		trans.dwBgID = rand()%(sizeof(lpwszBgName)/sizeof(OLECHAR*));

		// BGǂݍ
		hr = lpSDFactory->CreateBufferFromFile(
			lpwszBgName[ trans.dwBgID ], 0, NULL, 0, NULL, &lpBg );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}

	}


	// G[
	catch( exception& e )
	{
		
		MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );

		// N[Abv
		AppCleanUp();

		return FALSE;
	}


	SetTextMode( lpBack );


	return TRUE;
}


/*----------------------------------------------------------------------------*
|	AppACh
*----------------------------------------------------------------------------*/
void AppIdle( void )
{

	lpBack->Blt( lpBg, 0, 0, NULL, NULL, NULL );

	char szBuf[256];

	if( !trans.bTransition )
	{
		// gWV̐؂ւ
		try
		{
			if( GetActiveWindow() == hWnd )
			{
				if( GetAsyncKeyState( VK_LBUTTON )&0x8000 )
				{
					LoadRuleImage();

					SwapBG();

					trans.bTransition = true;
					trans.dwPhase = 0;

				}else if( GetAsyncKeyState( VK_RBUTTON )&0x8000 )
				{
					if( lpRule != NULL )
					{
						SwapBG();

						trans.bTransition = true;
						trans.dwPhase = 0;
					}
				}
			}
		}

		catch( exception& e )
		{
			MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );
			PostMessage( hWnd, WM_CLOSE, 0, 0 );
		}

		sprintf( szBuf, "Next>> ENbN, Replay>> NbN" );

	}else
	{

		// gWV`
		lpBack->UniversalTransBlt( 
			lpTransBg, 0, 0, NULL, NULL, NULL, 
			lpRule, trans.dwPhase, trans.Vague, 0 );

		// 1bŐ؂ւ (1bԂɉZl*t[oߎ)
		trans.dwPhase += 65535*FpsTimer.GetElapsed();

		if( trans.dwPhase > 65535 )
		{
			trans.bTransition = false;
		}

		sprintf( szBuf, "Phase=%3d%% Rule=\"%s\" Vague=%d", (trans.dwPhase*100/65535), trans.szRuleName, trans.Vague );
	}


	HDC hBackDC;
	COLORREF crOld;
	lpBack->GetDC( &hBackDC );

	crOld = SetTextColor( hBackDC, RGB(80,80,80) );
	TextOut( hBackDC, 2, 452, szBuf, strlen(szBuf));
	
	SetTextColor( hBackDC, RGB(255,255,255) );
	TextOut( hBackDC, 0, 450, szBuf, strlen(szBuf));

	SetTextColor( hBackDC, crOld );

	// ̕`
	DrawInfo( lpBack );


	// ĕ`
	//*
	HDC hDC = GetDC( hWnd );
	lpBack->Draw( hDC );
	ReleaseDC( hWnd, hDC );
	/*/
	InvalidateRect( hWnd, NULL, FALSE );
	UpdateWindow( hWnd );
	//*/
}


/*----------------------------------------------------------------------------*
|	AppN[Abv
*----------------------------------------------------------------------------*/
void AppCleanUp( void )
{
	SAFE_RELEASE( lpRule );
	SAFE_RELEASE( lpBg );
	SAFE_RELEASE( lpTransBg );
	SAFE_RELEASE( lpBack );
	SAFE_RELEASE( lpSDFactory );
}


/*----------------------------------------------------------------------------*
|	WM_PAINT
*----------------------------------------------------------------------------*/
void OnPaint( HDC hdc )
{
	if( lpBack == NULL ) return;

	lpBack->Draw( hdc );
}


/*----------------------------------------------------------------------------*
|	[摜̓ǂݍ
*----------------------------------------------------------------------------*/
void LoadRuleImage( void )
{
	// gWV`t@Cp[^ǂݍ
	FILE* fp = fopen( TRANSFILE, "r" );

	if( !fp ) throw exception( "t@CI[vG[" );

	// ÕgWV`ʒuɈړ
	fseek( fp, trans.dwFilePos, SEEK_SET );

	char buf[256];

	do
	{
		if( !fgets( buf, 256, fp ) )
		{
			// t@C̏I[ɗ߂
			if( feof(fp) )
			{
				rewind(fp);

				if( !fgets( buf, 256, fp ) )

					throw exception( "t@CG[" );
			}
		}

	}while( buf[0] == ';' || buf[0] == '\n' );

	// ̃|WVL^
	trans.dwFilePos = ftell( fp );
	fclose( fp );

	sprintf( trans.szRuleName, TRANSLIBPATH("%s"), strtok( buf, " \n" ) );

	// obt@Vague擾
	char* vague = strtok( NULL, " \n" );

	if( vague )
	{
		trans.Vague = atoi( vague );
	}else
	{
		trans.Vague = 32;
	}

	// [obt@̉
	SAFE_RELEASE( lpRule );

	HRESULT hr;

	// AnsiStringWideString
	OLECHAR wszRuleName[256];
	mbstowcs( wszRuleName, trans.szRuleName, 256 );

	// [摜̓ǂݍ
	hr = lpSDFactory->CreateBufferFromFile( wszRuleName, 0, NULL, 0, 0,  &lpRule );

	if( FAILED( hr ) )
	{
		throw exception("[摜̓ǂݍ݂Ɏs܂");
	}

}


/*----------------------------------------------------------------------------*
|	BG̃Xbv
*----------------------------------------------------------------------------*/
void SwapBG( void )
{

	// gWVobt@Ɍ݂BGʂRs[
	lpTransBg->Blt( lpBg, 0, 0, NULL, NULL, NULL );
	
	DWORD max_bg = sizeof(lpwszBgName)/sizeof(BSTR);
	DWORD tmp;

	// OBGƍBGԂȂ悤ɂ
	do
	{
		tmp = rand()%max_bg;

	}while( tmp == trans.dwBgID || tmp == trans.dwTransBgID );

	trans.dwTransBgID = trans.dwBgID;
	trans.dwBgID = tmp;

	// BGobt@̉
	SAFE_RELEASE( lpBg );

	HRESULT hr;

	// BGǂݍ
	hr = lpSDFactory->CreateBufferFromFile( 
		lpwszBgName[ trans.dwBgID ], 0, NULL, 0, 0, &lpBg );

	if( FAILED( hr ) )
	{
		throw exception("BG摜̓ǂݍ݂Ɏs");
	}
}