unit FpsTimer;

//////////////////////////////////////////////////////////////////////////////
//
// Delphip FPS^C}[R|[lg
//
// built on 2004/4/19
// WebSite: http://selna.hp.infoseek.co.jp
// E-Mail: selna_id@yahoo.co.jp
// Copyright(C) 2004 SELNA. All rights reserved.
//////////////////////////////////////////////////////////////////////////////
interface

uses Windows, MMSystem;

const
    FPSTIMER_NOWAIT = 0;
    FPSTIMER_60FPS  = 60;
    FPSTIMER_30FPS  = 30;

type
    TFpsTimer = class(TObject)
    protected
        f_dwLastTime: DWORD;
        f_dwWaitTime: DWORD;
        f_dwNowWaitTime: DWORD;
        f_dwFrameTime: array[0..63] of DWORD;

        f_dwFPS: DWORD;
        f_dwFrameTimeCount: DWORD;
        f_sFps: Single;

        f_timer_res: DWORD;
    public
        constructor Create;
        destructor Destroy; override;
        procedure WaitFrame;
        function GetFPS: Single;
        procedure SetFPSValue(dwFPS: DWORD = FPSTIMER_NOWAIT);
    end;

implementation

//----------------------------------------------------------------------------
//	RXgN^
//----------------------------------------------------------------------------
constructor TFpsTimer.Create;
var
    Ret: DWORD;
    tc: TIMECAPS;
begin

    Ret := timeGetDevCaps(@tc, sizeof(tc));

    if( Ret = TIMERR_NOERROR ) then
    begin
        // ŏ^C}x擾
        f_timer_res := tc.wPeriodMin;

        // ŏ^C}xݒ
        timeBeginPeriod( f_timer_res );
    end;

    SetFpsValue();

end;


//----------------------------------------------------------------------------
//	fXgN^
//----------------------------------------------------------------------------
destructor TFpsTimer.Destroy;
begin

    // ^C}\[X
    timeEndPeriod( f_timer_res );
    
    inherited;
end;


//----------------------------------------------------------------------------
//	ҋ@t[
//----------------------------------------------------------------------------
procedure TFpsTimer.WaitFrame;
var
    dwNowTime: DWORD;
    dwNowWait: DWORD;
    dwElapseTime: DWORD;
begin

    dwNowTime := timeGetTime();

    while true do
    begin
    { break down }

        if( f_dwFPS = FPSTIMER_NOWAIT ) then break;

        f_dwNowWaitTime := (f_dwNowWaitTime and $FFFF) + f_dwWaitTime;

        dwNowWait := f_dwNowWaitTime shr 16;

        dwElapseTime := dwNowTime - f_dwLastTime;

        if( dwElapseTime >= dwNowWait ) then break;

        Sleep( dwNowWait - dwElapseTime );

        dwNowTime := f_dwLastTime + dwNowWait;

        break;
    { break end }
    end;

    f_dwLastTime := dwNowTime;

    f_dwFrameTime[ f_dwFrameTimeCount and 63 ] := dwNowTime;
    inc(f_dwFrameTimeCount);

    if( f_dwFrameTimeCount = 128 ) then f_dwFrameTimeCount := 64;

end;


//----------------------------------------------------------------------------
//	FPS擾
//----------------------------------------------------------------------------
function TFpsTimer.GetFPS: Single;
var
    dwTmpTime: DWORD;

begin

    if( f_dwFrameTimeCount < 32 ) then
    begin
        result := 0;
        exit;
    end;

    if( f_dwFrameTimeCount < 64 ) then
    begin
        dwTmpTime :=
        f_dwFrameTime[ f_dwFrameTimeCount-1] - // ̃^C (or Ot[̃^C)
        f_dwFrameTime[ f_dwFrameTimeCount-32 ];// ̃^C31t[Õ^C

        if( dwTmpTime = 0 ) then dwTmpTime := 1;

        result := (1000*31)/dwTmpTime;
        exit;
    end;

    dwTmpTime :=
    f_dwFrameTime[ (f_dwFrameTimeCount-1) and 63 ] - // ̃^C (or Ot[̃^C)
    f_dwFrameTime[ f_dwFrameTimeCount and 63 ];      // ̃^C63t[Õ^C

    if( dwTmpTime = 0 ) then dwTmpTime := 1;
    
    result := (1000*63)/dwTmpTime;

end;


//----------------------------------------------------------------------------
//	FPSݒ
//----------------------------------------------------------------------------
procedure TFpsTimer.SetFPSValue(dwFPS: DWORD);
begin

    f_dwFPS := dwFPS;

   	// ݂̎Ԃ擾
	f_dwLastTime := timeGetTime();

    // ̏
	ZeroMemory( @f_dwFrameTime, sizeof(f_dwFrameTime));
    f_dwFrameTimeCount := 0;
    f_sFps := 0;
    f_dwNowWaitTime := 0;

    if( dwFPS = FPSTIMER_NOWAIT ) then exit;

    // 1t[őҋ@鎞ԂŒ菭ŕ\
    f_dwWaitTime := (1000 shl 16) div dwFPS;

end;

end.
