VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "FpsTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'****************************************************************************
' API
'****************************************************************************
Private Type TIMECAPS
    PeriodMin As Long
    PeriodMax As Long
End Type

Private Declare Function timeGetDevCaps Lib "winmm" ( _
ByRef tc As TIMECAPS, _
ByVal btc As Long _
) As Long

Private Declare Function timeBeginPeriod Lib "winmm" ( _
ByVal Period As Long _
) As Long

Private Declare Function timeEndPeriod Lib "winmm" ( _
ByVal Period As Long _
) As Long

Private Declare Function timeGetTime Lib "winmm" () As Long

Private Declare Sub Sleep Lib "kernel32" ( _
ByVal Milliseconds As Long _
)

Private Const TIMERR_NOERROR = 0

'/////////////////////////////////////////////////////////////////////////////
'
' VBp FPS^C}[NXW[
'
' built on 2004/4/19
' WebSite: http://selna.hp.infoseek.co.jp
' E-Mail: selna_id@yahoo.co.jp
' Copyright(C) 2004 SELNA. All rights reserved.
'/////////////////////////////////////////////////////////////////////////////

' class FpsTimer
' private:

Private m_LastTime As Long
Private m_WaitTime As Long
Private m_NowWaitTime As Long
Private m_FrameTime(64) As Long
Private m_FPS As Long
Private m_FrameTimeCount As Long
Private m_sFps As Single
Private m_timer_res As Long

' public:


'-----------------------------------------------------------------------------
'   RXgN^
'-----------------------------------------------------------------------------
Private Sub Class_Initialize()
    
    Dim tc As TIMECAPS
    Dim Ret As Long

    Ret = timeGetDevCaps(tc, Len(tc))
    
    If (Ret = TIMERR_NOERROR) Then
        
        m_timer_res = tc.PeriodMin
        
        Call timeBeginPeriod(m_timer_res)
        
    End If
    
    Call SetFPSValue(0)
        
End Sub


'-----------------------------------------------------------------------------
'   fXgN^
'-----------------------------------------------------------------------------
Private Sub Class_Terminate()
    
    Call timeEndPeriod(m_timer_res)
    
End Sub


'-----------------------------------------------------------------------------
'   FPSݒ
'-----------------------------------------------------------------------------
Public Sub WaitFrame()
    
    Dim NowTime As Long
    Dim NowWait As Long
    Dim ElapseTime As Long
    
    NowTime = timeGetTime()
    
    Do
    ' break down
        
        If (m_FPS = 0) Then Exit Do
    
        m_NowWaitTime = (m_NowWaitTime And &HFFFF&) + m_WaitTime
 
        NowWait = m_NowWaitTime \ &H10000
        
        ElapseTime = NowTime - m_LastTime
        
        If (ElapseTime >= NowWait) Then Exit Do
        
        Call Sleep(NowWait - ElapseTime)
      
        NowTime = m_LastTime + NowWait
        
        Exit Do
    ' break end
    Loop
    
    m_LastTime = NowTime
    
    m_FrameTime(m_FrameTimeCount And 63) = NowTime
    
    m_FrameTimeCount = m_FrameTimeCount + 1
    
    If (m_FrameTimeCount = 128) Then m_FrameTimeCount = 64
    
End Sub


'-----------------------------------------------------------------------------
'   FPS擾
'-----------------------------------------------------------------------------
Public Function GetFPS() As Single

    If (m_FrameTimeCount < 32) Then
        GetFPS = 0
        Exit Function
    End If
    
    Dim TmpTime As Long
    
    If (m_FrameTimeCount < 64) Then
    
        TmpTime = _
        m_FrameTime(m_FrameTimeCount - 1) - _
        m_FrameTime(m_FrameTimeCount - 32)
        
        'GetFPS = (CLng(1000) * CLng(31)) / TmpTime
        GetFPS = 31000 / TmpTime
        Exit Function
        
    End If
    
    TmpTime = _
    m_FrameTime((m_FrameTimeCount - 1) And 63) - _
    m_FrameTime(m_FrameTimeCount And 63)
    
    'GetFPS = (CLng(1000) * CLng(63)) / TmpTime
    GetFPS = 63000 / TmpTime
    
End Function


'-----------------------------------------------------------------------------
'   FPSݒ
'-----------------------------------------------------------------------------
Public Sub SetFPSValue(ByVal fps As Long)
    
    m_FPS = fps
    
    ' ݂̎Ԃ擾
    m_LastTime = timeGetTime()
    
    ' ̏
    Dim i As Long
    For i = 0 To 64
        m_FrameTime(i) = 0
    Next
    
    m_FrameTimeCount = 0
    m_sFps = 0
    m_NowWaitTime = 0
    
    If (fps = 0) Then Exit Sub
    
    ' 1t[őҋ@鎞ԂŒ菭ŕ\
    ' m_WaitTime = (1000 << 16) \ FPS
    m_WaitTime = (1000 * &H10000) \ fps
    
End Sub
