
#include "stdafx.h"

char			CComSimpleModule::m_szModulePath[MAX_PATH] = "";
OBJECT_ENTRY*	CComSimpleModule::m_pObjectMap = NULL;
CComRef			CComSimpleModule::m_cObjectsAndLocks = 0;


/*----------------------------------------------------------------------------*
|	CLSIDAnsiɕϊ
*----------------------------------------------------------------------------*/
HRESULT CComSimpleModule::GetAnsiStringCLSID( REFCLSID rclsid, char* lpszCLSID, long nCharMax )
{
	LPOLESTR lpwszCLSID = NULL;

	HRESULT hr = ::StringFromCLSID( rclsid, &lpwszCLSID );

	if( FAILED(hr) )
	{
		::CoTaskMemFree( lpwszCLSID );
		return hr;
	}

	::wcstombs( lpszCLSID, lpwszCLSID, nCharMax );
    ::CoTaskMemFree(lpwszCLSID);

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	NXL[̓o^
*----------------------------------------------------------------------------*/
HRESULT CComSimpleModule::RegisterClassKey( REFCLSID rclsid, LPCSTR lpszModulePath, LPCSTR lpszComName, LPCSTR lpszProgID )
{
	char szCLSID[80];

	HRESULT hr = GetAnsiStringCLSID( rclsid, szCLSID, sizeof(szCLSID) );
	
	if( FAILED(hr) )
		return hr;

	char szCLSKey[256] = "CLSID\\";
	::strcat( szCLSKey, szCLSID );

	char szProgKey[256];
	::strcpy( szProgKey, lpszProgID );

	const char* szRegTbl[6][4] = 
	{	// L[, TuL[, O, l
		{ szCLSKey,  NULL,				NULL,				lpszComName		},
		{ szCLSKey,  "InprocServer32",	NULL,				lpszModulePath	},
		{ szCLSKey,  "InprocServer32",	"ThreadingModel",	"Apartment"		},
		{ szCLSKey,  "ProgID",			NULL,				lpszProgID		},
		{ szProgKey, NULL,				NULL,				lpszComName		},
		{ szProgKey, "CLSID",			NULL,				szCLSID			},
	};

	for( int i = 0; i < 6; i++ )
	{
		HKEY hKey;
		LONG err;

		char szSubKey[256];
		::strcpy( szSubKey, szRegTbl[i][0] );

		if( szRegTbl[i][1] )
		{
			::strcat( szSubKey, "\\" );
			::strcat( szSubKey, szRegTbl[i][1] );
		}

		err = ::RegCreateKeyEx( HKEY_CLASSES_ROOT, szSubKey, NULL,
			NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, NULL );

		if( err != ERROR_SUCCESS )
		{
			UnregisterServer();
			return S_FALSE;
		}

		err = ::RegSetValueEx( hKey, szRegTbl[i][2], 0, REG_SZ,
			(const BYTE*)szRegTbl[i][3], strlen(szRegTbl[i][3])+1 );

		::RegCloseKey( hKey );

		if( err != ERROR_SUCCESS )
		{
			UnregisterServer();
			return S_FALSE;
		}
	}

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	NXL[̓o^
*----------------------------------------------------------------------------*/
HRESULT CComSimpleModule::UnregisterClassKey( REFCLSID rclsid, LPCSTR lpszProgID )
{
	char szCLSID[80];

	HRESULT hr = GetAnsiStringCLSID( rclsid, szCLSID, sizeof(szCLSID) );
	
	if( FAILED(hr) )
		return hr;

	char szCLSKey[256] = "CLSID\\";
	::strcat( szCLSKey, szCLSID );

	char szProgKey[256];
	::strcpy( szProgKey, lpszProgID );

	const char* szRegKeyTbl[5][2] = 
	{	// L[, TuL[, 
		{ szCLSKey,  NULL,				},
		{ szCLSKey,  "InprocServer32",	},
		{ szCLSKey,  "ProgID",			},
		{ szProgKey, NULL,				},
		{ szProgKey, "CLSID",			},
	};

	for( int i = 4; i >= 0; i-- )
	{
		char szSubKey[256];
		::strcpy( szSubKey, szRegKeyTbl[i][0] );

		if( szRegKeyTbl[i][1] )
		{
			::strcat( szSubKey, "\\" );
			::strcat( szSubKey, szRegKeyTbl[i][1] );
		}

		LONG err = ::RegDeleteKey( HKEY_CLASSES_ROOT, szSubKey );

		if( err != ERROR_SUCCESS )
			hr = S_FALSE;
	}

	return hr;
}


/*----------------------------------------------------------------------------*
|	COMW[NX̏
*----------------------------------------------------------------------------*/
void CComSimpleModule::Initialize( HMODULE hModule, OBJECT_ENTRY* pObjectMap )
{
	::GetModuleFileName( hModule, m_szModulePath, MAX_PATH );
		
	m_pObjectMap = pObjectMap;

	::setlocale( LC_ALL, "jpn" );
}


/*----------------------------------------------------------------------------*
|	COMNXIuWFNg̎擾
*----------------------------------------------------------------------------*/
HRESULT CComSimpleModule::GetClassObject( REFCLSID rclsid, REFIID riid, void** ppv )
{
	IClassFactory* pFactory = NULL;
	HRESULT hr = CLASS_E_CLASSNOTAVAILABLE;

	for( OBJECT_ENTRY* pObjMap=m_pObjectMap; pObjMap->pClsID != NULL; pObjMap++ )
	{
		if( *pObjMap->pClsID == rclsid )
		{
			pFactory = pObjMap->ClassFactory_CreateInstance();
			
			if( pFactory == NULL )
			{
				hr = E_OUTOFMEMORY;
			}else
			{
				hr = S_OK;
			}

			break;
		}
	}

	if( hr != S_OK ) return hr;
	
	hr = pFactory->QueryInterface( riid, ppv );

	pFactory->Release();

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	COMT[o[o^
*----------------------------------------------------------------------------*/
HRESULT CComSimpleModule::RegisterServer( void )
{
	HRESULT hr;
	
	for( OBJECT_ENTRY* pObjMap=m_pObjectMap ;pObjMap->pClsID != NULL; pObjMap++ )
	{
		hr = RegisterClassKey( *pObjMap->pClsID, m_szModulePath, 
			pObjMap->lpszComName, pObjMap->lpszPorgID );

		if( FAILED(hr) ) return hr;
	}

	//^CvCuo^
	LPTYPELIB pITypeLib = NULL;

    //^CvCu(ITypeLib)p̃pX쐬
    OLECHAR wszFile[MAX_PATH*2];
    ::mbstowcs(wszFile, m_szModulePath, MAX_PATH);

    //^CvCũ[h
    hr = ::LoadTypeLib( wszFile, &pITypeLib );

    if( FAILED(hr) )
        return hr;

    hr = ::RegisterTypeLib( pITypeLib, wszFile, NULL );
    
	pITypeLib->Release();

	return hr;
}


/*----------------------------------------------------------------------------*
|	COMT[o[o^
*----------------------------------------------------------------------------*/
HRESULT CComSimpleModule::UnregisterServer( void )
{
	HRESULT hr;
	
	for( OBJECT_ENTRY* pObjMap=m_pObjectMap ;pObjMap->pClsID != NULL; pObjMap++ )
	{
		hr = UnregisterClassKey( *pObjMap->pClsID, pObjMap->lpszPorgID );

		if( FAILED(hr) ) return hr;
	}

	// ^CvCuo^
	LPTYPELIB pITypeLib = NULL;

	OLECHAR wszFile[MAX_PATH*2];
	::mbstowcs( wszFile, m_szModulePath, MAX_PATH );

	//^CvCũ[h(ITypeLib)
	hr = ::LoadTypeLib( wszFile, &pITypeLib );
	if (FAILED(hr))
		return hr ;

	//폜̂߂Ƀ^CvCu擾
	TLIBATTR* pAttr;
	hr = pITypeLib->GetLibAttr( &pAttr );

	if(FAILED(hr))
		return hr;

	//^CvCu̓o^̍폜
	hr = ::UnRegisterTypeLib( pAttr->guid, pAttr->wMajorVerNum, pAttr->wMinorVerNum,
							  pAttr->lcid, pAttr->syskind );

	pITypeLib->ReleaseTLibAttr( pAttr );
	pITypeLib->Release();

	return S_OK;
}


/*----------------------------------------------------------------------------*
|	C^[tFCXLXg֐
*----------------------------------------------------------------------------*/
HRESULT __InternalQueryInterface( void* This, const INTERFACE_ENTRY* pEntries, REFIID riid, void** ppv )
{
	if( ppv == NULL ) return E_POINTER;

	HRESULT hr = E_NOINTERFACE;

	if( IsEqualIID( riid, IID_IUnknown ) )
	{
		*ppv = (BYTE*)This+pEntries->dwOffset;
		hr = S_OK;

	}else
	{
		for(;pEntries->pIID != NULL; pEntries++)
		{
			if( IsEqualIID( riid, *pEntries->pIID ) )
			{
				*ppv = (BYTE*)This+pEntries->dwOffset;
				hr = S_OK;
				break;
			}
		}

	}
	
	if( hr != S_OK )
	{	
		*ppv = NULL;
	}else
	{
		reinterpret_cast<IUnknown*>(*ppv)->AddRef();
	}

	return hr;
}
