
/******************************************************************************
*	SDIB32GL DLL Main Source
******************************************************************************/
#include "stdafx.h"
#include "sdib32gl.h"
#include "sdib32glbase.h"
#include "sdib32glfactory.h"
#include "resource.h"
#include "sdib32gl_c.c"

SET_NEW_THROW;


// LO[oϐ
#if _DEBUG
#pragma data_seg(".shdib32")
ULONG	CDebugOut::m_ulRef = 0;
#pragma data_seg()
char	CDebugOut::m_szLogName[256] = "";
#endif

HINSTANCE			g_hInstance = 0;
#pragma warning( disable : 4786 )
map<HRESULT, DWORD> g_ErrorMap;
#pragma warning( default : 4786 )

CDebugOut dummy;

_BEGIN_OBJECT_MAP( ObjectMap )
	_OBJECT_ENTRY( CLSID_SDib32GLFactory, CSDib32GLFactory, "SDIB32GL.SDib32GLFactory.1", "SELNA DIB32 Graphic Libraries Factory Object" )
_END_OBJECT_MAP()


/*----------------------------------------------------------------------------*
|	DLL Gg[|Cg
*----------------------------------------------------------------------------*/
STDAPI_(BOOL) DllMain( HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved )
{
	switch( ul_reason_for_call )
	{
	case DLL_PROCESS_ATTACH:

		// COMW[
		CComSimpleModule::Initialize( (HMODULE)hModule, ObjectMap );

		// CX^Xnhݒ
		g_hInstance = hModule;

		// TCRTCe[u쐬
		CSinCosTable();

		// mNe[u쐬
		CSDib32GLBase::InitMonoTable();

		// G[}bvݒ (key=G[R[h, l=\[XID)
		g_ErrorMap[ SDIB32GLERR_SDIB32GLALREADYCREATED ] = IDS_SDIB32GLERR_SDIB32GLALREADYCREATED;
		g_ErrorMap[ SDIB32GLERR_DIBNOTCREATED ]       = IDS_SDIB32GLERR_DIBNOTCREATED;
		g_ErrorMap[ SDIB32GLERR_MEMORYDCNOTCREATED ]  = IDS_SDIB32GLERR_MEMORYDCNOTCREATED;
		g_ErrorMap[ SDIB32GLERR_FILENOTFOUND ]        = IDS_SDIB32GLERR_FILENOTFOUND;
		g_ErrorMap[ SDIB32GLERR_FILENOTCREATED ]      = IDS_SDIB32GLERR_FILENOTCREATED;
		g_ErrorMap[ SDIB32GLERR_NOTINITIALIZED ]      = IDS_SDIB32GLERR_NOTINITIALIZED;
		g_ErrorMap[ SDIB32GLERR_INVALIDOBJECT ]       = IDS_SDIB32GLERR_INVALIDOBJECT;
		g_ErrorMap[ SDIB32GLERR_INVALIDPARAMS ]		  = IDS_SDIB32GLERR_INVALIDPARAMS;
		g_ErrorMap[ SDIB32GLERR_UNSUPPORTEDFILE ]     = IDS_SDIB32GLERR_UNSUPPORTEDFILE;
		g_ErrorMap[ SDIB32GLERR_UNSUPPORTEDBITCOUNT ] = IDS_SDIB32GLERR_UNSUPPORTEDBITCOUNT;
		g_ErrorMap[ SDIB32GLERR_UNSUPPORTEDFORMAT ]   = IDS_SDIB32GLERR_UNSUPPORTEDFORMAT;
		g_ErrorMap[ SDIB32GLERR_EXCEPTION ]			  = IDS_SDIB32GLERR_EXCEPTION;
		g_ErrorMap[ SDIB32GLERR_ALREADYINITIALIZED ]  = IDS_SDIB32GLERR_ALREADYINITIALIZED;
		g_ErrorMap[ SDIB32GLS_ROTATEBLT64BIT ]        = IDS_SDIB32GLS_ROTATEBLT64BIT;
		g_ErrorMap[ SDIB32GLS_INVALIDPOSITION ]		  = IDS_SDIB32GLS_INVALIDPOSITION;
		break;
	case DLL_PROCESS_DETACH:

		// G[}bvNA
		g_ErrorMap.clear();
		break;
	}

	return TRUE;
}


/*----------------------------------------------------------------------------*
|	COMNXIuWFNg擾
*----------------------------------------------------------------------------*/
STDAPI DllGetClassObject( REFCLSID rclsid, REFIID riid, void** ppv )
{
	return CComSimpleModule::GetClassObject( rclsid, riid, ppv );
}


/*----------------------------------------------------------------------------*
|	COMT[o[̎
*----------------------------------------------------------------------------*/
STDAPI DllCanUnloadNow( void )
{
	return CComSimpleModule::GetLockCount() == 0 ? S_OK : S_FALSE;
}


/*----------------------------------------------------------------------------*
|	COMT[o[̃WXgo^
*----------------------------------------------------------------------------*/
STDAPI DllRegisterServer( void )
{
	return CComSimpleModule::RegisterServer();
}


/*----------------------------------------------------------------------------*
|	COMT[o[̃WXgo^
*----------------------------------------------------------------------------*/
STDAPI DllUnregisterServer( void )
{
	return CComSimpleModule::UnregisterServer();
}


/*----------------------------------------------------------------------------*
|	SDIB32GLt@Ng֐@(DLLÓINAC/C++p)
*----------------------------------------------------------------------------*/
STDAPI SDIB32GLFactoryCreate( const SDIB32GLCREATEMODE Mode, LPVOID* lplpSDIB32GLFactory, REFIID riid )
{
	if( lplpSDIB32GLFactory == NULL ) return E_POINTER;

	// CLSID_SDib32GLFactorỹNXt@NgC^[tFCX擾
	IClassFactory* pClassFactory;

	HRESULT hr = CComSimpleModule::GetClassObject( 
		CLSID_SDib32GLFactory, IID_IClassFactory, (void**)&pClassFactory );

	if( SUCCEEDED(hr) )
	{
		// CLSID_SDib32GLFactorỹCX^X𐶐
		CSDib32GLFactory* pSDib32GLFactory;

		hr = pClassFactory->CreateInstance( NULL, riid, (void**)&pSDib32GLFactory );
		
		pClassFactory->Release();

		if( SUCCEEDED(hr) )
		{
			// SDib32GLFactoryNX̏
			hr = pSDib32GLFactory->Initialize( Mode );
		}

		// AhXRs[(sNULL|C^)
		*lplpSDIB32GLFactory = pSDib32GLFactory;
	}

	return hr;
}


/*----------------------------------------------------------------------------*
|	SDIB32GĽ݂̃o[W擾
*----------------------------------------------------------------------------*/
STDAPI_(DWORD) SDIB32GLGetVersion( void )
{

	return SDIB32GL_VERSION;

}


/*----------------------------------------------------------------------------*
|	G[eLXg擾
*----------------------------------------------------------------------------*/
STDAPI_(DWORD) SDIB32GLGetErrorText( HRESULT hr, char* pBuffer, int nBufferMax )
{
	if( g_ErrorMap.count( hr ) )
	{
		return (DWORD)::LoadString( g_hInstance, g_ErrorMap[ hr ], pBuffer, nBufferMax );

	}else
	{
		return ::FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM |
						 FORMAT_MESSAGE_IGNORE_INSERTS,
						 NULL, hr,
						 MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
						(LPTSTR)pBuffer, nBufferMax, NULL);
	}
}


/*----------------------------------------------------------------------------*
|	CPUMMXɑΉĂ邩ǂ
*----------------------------------------------------------------------------*/
#pragma warning( disable : 4035 )
STDAPI_(BOOL) SDIB32GLIsMMX( void )
{
	__asm
	{
		// CPUID̃T|[g`FbN
		pushfd
        pop eax
        mov ecx, eax
        xor eax, 0x200000
        push eax
        popfd
        pushfd
        pop eax
        and eax, 0x200000
        and ecx, 0x200000
        xor eax, ecx
        jnz cpuid_true
		mov eax, 0
		jmp	mmx_false

		// MMXT|[g`FbN
cpuid_true:
		mov eax, 1
		cpuid
		and edx, 0x800000
		shr edx, 23
		mov eax, edx

mmx_false:
	}
}
#pragma warning( default : 4035 )


/*----------------------------------------------------------------------------*
|	mۂBSTR(C/C++p)
|
|	ISDib32GL::GetFileNameŎ擾BSTR񓙂
*----------------------------------------------------------------------------*/
STDAPI SDIB32GLFreeBSTR( BSTR* pbstr )
{
	if( pbstr == NULL ) return E_POINTER;

	if( *pbstr == NULL ) return S_FALSE;

	::SysFreeString( *pbstr );

	*pbstr = NULL;

	return S_OK;
}
