#ifndef _INC_SLIB_CFILE
#define _INC_SLIB_CFILE


/*----------------------------------------------------------------------------*
|	File class
*----------------------------------------------------------------------------*/
typedef class CFile
{
protected:

	FILE*	m_lpFile;
	string	m_strOpenMode;
	string	m_strFullPathName;

public:

	CFile();
	CFile( const char* lpszFileName, const char *lpMode );
	virtual ~CFile();

	void Open( const char* lpszFileName, const char *lpMode );
	void Close( void );
	size_t Write( void* lpBuffer, size_t Size, size_t Count ){
		return ::fwrite( lpBuffer, Size, Count, m_lpFile );
	}
	size_t Read( void* lpBuffer, size_t Size, size_t Count ){
		return ::fread( lpBuffer, Size, Count, m_lpFile );
	}
	int Seek( LONG lOffset, int nOrigin ){
		return ::fseek( m_lpFile, lOffset, nOrigin );
	}
	int SeekToBegin( void ){ return Seek( 0L, SEEK_SET ); }
	int SeekToEnd( void ){ return Seek( 0L, SEEK_END ); }
	long GetPosition( void ){ return ::ftell( m_lpFile ); }
	int Eof( void ){ return feof( m_lpFile ); }
	DWORD GetSize( void );
	string GetFileName( void );
	string GetFullPathName( void ){ if(m_strFullPathName.length()==0) return ""; return m_strFullPathName; }
	string GetFileDir( void );
	string GetFileExt( void );
	string GetMode( void ){ if( m_strOpenMode.length() == 0 ) return ""; return m_strOpenMode; }
	BOOL GetFileTime( LPSYSTEMTIME lpCreationTime, LPSYSTEMTIME lpLastAccessTime, LPSYSTEMTIME lpLastWriteTime );
	BOOL SetFileTime( LPSYSTEMTIME lpCreationTime, LPSYSTEMTIME lpLastAccessTime, LPSYSTEMTIME lpLastWriteTime );
	BOOL Copy( const char* lpszNewFile, BOOL bFileIfExists ){
		if( m_strFullPathName.length() == 0 ) return FALSE;
		return CopyFile( m_strFullPathName.c_str(), lpszNewFile, bFileIfExists );
	}
	BOOL SetEOF( void );
	FILE* GetPtr( void ){ return m_lpFile; }
	operator !(){ return !m_lpFile; }
	operator FILE*(){ return m_lpFile; }

public:

	static bool IsExist( const char* lpszFileName ){ return ::GetFileAttributes(lpszFileName) != 0xFFFFFFFF ? true : false; }
	static int Remove( const char* lpszFileName ){ return ::remove( lpszFileName ); }
	static int Rename( const char* lpszOldName, const char* lpszNewName ){ return rename( lpszOldName, lpszNewName ); }
	static DWORD GetAttributes( const char* lpszFileName ){ return ::GetFileAttributes( lpszFileName ); }
	static DWORD SetAttributes( const char* lpszFileName, DWORD dwFileAttributes ){ return ::SetFileAttributes( lpszFileName, dwFileAttributes ); }

}CFILE, FAR* LPCFILE;


#endif /* _INC_SLIB_CFILE */