#ifndef _INC_SLIB_auto_array
#define _INC_SLIB_auto_array

#ifndef _TRACE
#define _TRACE
#endif

namespace selna
{

/*----------------------------------------------------------------------------*
|	auto_ptrEx z ev[gNX
*----------------------------------------------------------------------------*/
template <class T> class auto_array
{
protected:

	bool	_Owns;		// |C^̏L
	T*		_Ptr;		// |C^

	typedef auto_array<T> this_type;

public:

	// RXgN^ (|C^0łȂL)
	explicit auto_array( T* _P = 0 ) : _Owns(_P != 0), _Ptr(_P) { if(_Ptr) _TRACE("new [] auto_array::auto_array _Ptr=%#08x this=%#08x\n",_Ptr,this); }

	// Rs[RXgN^ (|C^ړLn)
	auto_array( const auto_array<T>& _rhs ) : _Owns(_rhs._Owns), _Ptr(_rhs.release()) { if(_Ptr) _TRACE("copy auto_array::auto_array _Ptr=%#08x this=%#08x\n",_Ptr,this); }

	// fXgN^ (L鎞|C^폜)
	~auto_array() { if( _Owns ){ delete [] _Ptr; _TRACE("delete [] auto_array::~auto_array _Ptr=%#08x this=%#08x\n",_Ptr,this);} }

	// Rs[ 
	// (|C^ꍇŏL鎞n
	// |C^ႤꍇA|C^͍폜ꏊLn
	// ̌Eӑ̐|C^Rs[)
	auto_array<T>& operator=( const auto_array<T>& _rhs ) {
		if( this != &_rhs ) {
			if( _Ptr != _rhs._Ptr ) {
				if( _Owns ){ delete [] _Ptr; _TRACE("delete [] auto_array::operator= _Ptr=%#08x this=%#08x\n",_Ptr,this); }
				_Owns = _rhs._Owns;
			}else if( _rhs._Owns ) {
				_Owns = true;
			}
			_Ptr = _rhs.release();
			if(_Ptr) _TRACE("copy auto_array::operator= _Ptr=%#08x this=%#08x\n",_Ptr,this);
		}
		return *this;
	}

	// |C^̒l擾
	T& operator[]( int i ) const { return _Ptr[i]; }

	// |C^擾
	T* get( int i = 0 ) const { return &_Ptr[i]; }

	// L̉
	T* release( void ) const {
		const_cast<this_type*>(this)->_Owns = false;
		return _Ptr;
	}

	// |C^_PŃZbg (_P0łȂꍇL)
	void reset( T* _P = 0 ) {
		// XR[v甲ƃfXgN^N
		// (LĂꍇ|C^͍폜)
		this_type(_P).swap(*this);
		// *this = this_type(_P); ɓ
	}

	// Xbv (l)
	void swap( auto_array<T>& b ) {
		T*		tmpPtr  = b._Ptr;
		bool	tmpOwns = b._Owns;
		b._Ptr  = _Ptr;
		b._Owns = _Owns;
		_Ptr  = tmpPtr;
		_Owns = tmpOwns;
	}

	// |C^擾 (T*ŃLXg)
	operator T*() const { return _Ptr; }

};

};

#endif /* _INC_SLIB_auto_array */