#ifndef _INC_SDIB32GLFACTORY
#define _INC_SDIB32GLFACTORY


/*----------------------------------------------------------------------------*
|	SDIB32GLFactory Class
*----------------------------------------------------------------------------*/
class CSDib32GLFactory : public ISDib32GLFactory
{
	friend class CSDib32GLBase;

protected:

	auto_ptrEx<CFactoryBase>	m_pFactory;
	list<CSDib32GLBase*>		m_SDib32GLList;
	DWORD						m_dwUseSysMem;

protected:

	INLINEMETHODIMP CreateInstance( REFIID riid, void** ppvObj );

	/*** Common Interface's Internal Methods ***/
	INLINEMETHODIMP InternalCreateBuffer( long nWidth, long nHeight, SDIB32GLCOLOR FillColor, HDC hDC, REFIID riid, void** ppvObj );
	INLINEMETHODIMP InternalCreateBufferFromFile( const BSTR bstrFileName, long nOffset, const BSTR bstrSpiDir, SDIB32GLCOLOR ColorKey, HDC hDC, REFIID riid, void** ppvObj );
	INLINEMETHODIMP InternalCreateBufferFromMemory( const void* pvMemory, long nSize, const BSTR bstrSpiDir, SDIB32GLCOLOR ColorKey, HDC hDC, REFIID riid, void** ppvObj );
	INLINEMETHODIMP InternalCreateBufferFromResource( HINSTANCE hInstance, const BSTR bstrBitmapID, SDIB32GLCOLOR ColorKey, HDC hDC, REFIID riid, void** ppvObj );
	INLINEMETHODIMP InternalDuplicateBuffer( CSDib32GLBase* pOriginal, REFIID riid, void** ppvObj );
	
public:

	CSDib32GLFactory() _THROW0();
	virtual ~CSDib32GLFactory();


	_BEGIN_COM_MAP( CSDib32GLFactory )
		_COM_INTERFACE_ENTRY( ISDib32GLFactory )
	_END_COM_MAP()

	/*** ISDib32GLFactory methods ***/
	STDMETHODIMP Initialize( SDIB32GLCREATEMODE Mode );
	STDMETHODIMP CreateBuffer( long nWidth, long nHeight, SDIB32GLCOLOR FillColor, HDC hDC, ISDib32GL** ppRet );
	STDMETHODIMP CreateBufferFromFile( const BSTR bstrFileName, long nOffset, const BSTR bstrSpiDir, SDIB32GLCOLOR ColorKey, HDC hDC, ISDib32GL** ppRet );
	STDMETHODIMP CreateBufferFromMemory( const void* pvMemory, long nSize, const BSTR bstrSpiDir, SDIB32GLCOLOR ColorKey, HDC hDC, ISDib32GL** ppRet );
	STDMETHODIMP CreateBufferFromResource( HINSTANCE hInstance, const BSTR bstrBitmapID, SDIB32GLCOLOR ColorKey, HDC hDC, ISDib32GL** ppRet );
	STDMETHODIMP DuplicateBuffer( ISDib32GL* pOriginal, ISDib32GL** ppRet );
	STDMETHODIMP GetUseSysMem( LPDWORD lpdwUse );
	STDMETHODIMP GetBufferCount( LPDWORD lpdwCount );
	STDMETHODIMP EnumBuffers( LPSDIB32GLENUMBUFFERSCALLBACK lpEnumBuffersCallback, LPARAM lParam );
};


#endif /* _INC_SDIB32GLFACTORY */